﻿namespace UltraGridApplication
{
    using Infragistics.Win.Misc;
    using System;
    using System.Data;
    using System.Linq;
    using System.Windows.Forms;

    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraGrid1.DataSource = this.GetData();
            this.ultraButton1.Name = "Id";
            this.ultraTextEditor1.Name = "Name";
            this.ultraCombo1.Name = "Quantity";
        }

        private DataSet GetData()
        {
            DataSet dataSet = new DataSet();
            DataTable table = dataSet.Tables.Add("table1");
            table.Columns.Add("Id", typeof(int)).AutoIncrement = true;
            table.Columns.Add("Name", typeof(string));
            table.Columns.Add("Quantity", typeof(int));
            dataSet = AddData(dataSet);
            return dataSet;
        }

        private DataSet AddData(DataSet dataSet)
        {
            dataSet.Tables["table1"].Rows.Add(new object[] { null, "Beverage", 50 });
            dataSet.Tables["table1"].Rows.Add(new object[] { null, "Appliances", 5, });
            return dataSet;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.AutoFitStyle = Infragistics.Win.UltraWinGrid.AutoFitStyle.ResizeAllColumns;
        }

        private void ultraGrid1_AfterColPosChanged(object sender, Infragistics.Win.UltraWinGrid.AfterColPosChangedEventArgs e)
        {
            // This event is raised when column is moved, sized or swapped
            // Therefore we handle it only when e.PosChanged is equal to PosChanged.Sized
            if (e.PosChanged == Infragistics.Win.UltraWinGrid.PosChanged.Sized)
            {
                string columnCaption = e.ColumnHeaders[0].Caption;
                Control controlToResize = 
                    this.Controls.OfType<Control>()
                    .Where(control => control.Name == e.ColumnHeaders[0].Caption)
                    .FirstOrDefault();
                controlToResize.Width = e.ColumnHeaders[0].SizeResolved.Width;
            }
        }

        private void ultraGrid1_InitializeLayout_1(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            foreach (var column in e.Layout.Bands[0].Columns)
            {
                foreach (var control in this.Controls.OfType<Control>())
                {
                    if (column.Key == control.Text)
                    {
                        control.Width = column.Width;
                        break;
                    }
                }
            }
        }
    }
}
